SystemOrganization addCategory: #PhileasFogg!

Object subclass: #PFButtonModel
	instanceVariableNames: 'controller modelClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PhileasFogg'!

!PFButtonModel methodsFor: 'as yet unclassified' stamp: 'hjo 11/16/2011 21:04'!
controller: aPhileasFoggController 

	controller := aPhileasFoggController! !

!PFButtonModel methodsFor: 'as yet unclassified' stamp: 'hjo 11/16/2011 21:04'!
modelClass: anAddClassChangeClass 

	modelClass := anAddClassChangeClass! !

!PFButtonModel methodsFor: 'as yet unclassified' stamp: 'hjo 11/16/2011 21:05'!
nameOfModelClass

	^modelClass name! !

!PFButtonModel methodsFor: 'as yet unclassified' stamp: 'hjo 11/16/2011 21:06'!
performButtonAction

	controller topicClass: modelClass  ! !

Object subclass: #PhileasFogg
	instanceVariableNames: 'topicClass classesReferencingTopicClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PhileasFogg'!

!PhileasFogg methodsFor: 'as yet unclassified' stamp: 'hjo 11/16/2011 20:17'!
classesReferencingTopicClass
	^classesReferencingTopicClass ifNil: [
		classesReferencingTopicClass:=((topicClass theNonMetaClass asNode users collect: [ :each | each theClass theNonMetaClass ]) asSet
		copyWithout: topicClass) asSortedCollection: (SortDescriptor ascendingBy: #name).
	].
	 ! !

!PhileasFogg methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 17:01'!
goSuperclass

	self topicClass superclass isNil ifFalse: [self topicClass: self topicClass superclass ]! !

!PhileasFogg methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 11:32'!
instanceVariableNamesOfTopicClass
	^ topicClass instVarNames! !

!PhileasFogg methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 11:28'!
nameOfSuperclassOfTopicClass
	^ topicClass superclass name! !

!PhileasFogg methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 11:28'!
nameOfTopicClass
	^ topicClass name! !

!PhileasFogg methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 18:18'!
paragraphOfInstanceVariableNames

	^String streamContents: [:stream| self instanceVariableNamesOfTopicClass do: [:each| stream nextPutAll: each ] separatedBy: [stream cr]  ]  ! !

!PhileasFogg methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 11:52'!
topicClass

	^ topicClass! !

!PhileasFogg methodsFor: 'as yet unclassified' stamp: 'hjo 11/16/2011 21:37'!
topicClass: aClass 

	topicClass := aClass.
	classesReferencingTopicClass := nil.
	self changed: #topicClass.
! !

Object subclass: #PhileasFoggController
	instanceVariableNames: 'window model contentView classNameTextMorph superclassButton userClassButtonesMorph buttons instanceVariablesMorph scrollPane point textMorph contentViewOfScrollPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PhileasFogg'!

!PhileasFoggController methodsFor: 'view making' stamp: 'hjo 11/14/2011 17:32'!
classNameTextMorph

	^classNameTextMorph ifNil: [
		classNameTextMorph := model nameOfTopicClass asMorph.
		classNameTextMorph font:  (StrikeFont familyName: #Accuny size: 30).
		classNameTextMorph top: self superclassButton bottom + 10. 
		]! !

!PhileasFoggController methodsFor: 'view making' stamp: 'hjo 11/18/2011 20:14'!
contentView

	contentView isNil ifTrue: [
		contentView := Morph new. contentView extent: 300@500.
		contentView addMorph: self superclassButton.
		contentView addMorph: self classNameTextMorph.
		contentView addMorph: self scrollPane.
		].
	^contentView! !

!PhileasFoggController methodsFor: 'as yet unclassified' stamp: 'hjo 11/17/2011 21:37'!
createButtonList

	| lastButton buttonHeights |
	userClassButtonesMorph removeAllMorphs.
	lastButton := nil.

	buttons := model classesReferencingTopicClass collect: 
	[:each| | button buttonModel |
		buttonModel := PFButtonModel new.
		buttonModel controller: model.
		buttonModel modelClass: each.
		button := PluggableButtonMorph on: buttonModel getState: nil action: #performButtonAction label: #nameOfModelClass.
		userClassButtonesMorph addMorph: button.
		lastButton 
			ifNil: [button topLeft: userClassButtonesMorph topLeft]
			ifNotNil: [button topLeft: lastButton bottomLeft].
		lastButton := button.
	].
	buttonHeights := buttons collect: #height.
	userClassButtonesMorph height: (buttonHeights isEmpty ifTrue: [30] ifFalse: [buttonHeights sum]).
! !

!PhileasFoggController methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 17:17'!
goSuperclass

	model goSuperclass! !

!PhileasFoggController methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 17:12'!
initialize

	super initialize.
	self model: PhileasFogg new.! !

!PhileasFoggController methodsFor: 'view making' stamp: 'hjo 11/17/2011 21:03'!
instanceVariablesMorph

	^instanceVariablesMorph ifNil: [
		instanceVariablesMorph:= TextMorph new.
		instanceVariablesMorph contents: model paragraphOfInstanceVariableNames.
 		]  ! !

!PhileasFoggController methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 17:18'!
model: aPhileasFogg 
  
	model ifNotNil: [ model breakDependents ].
	model := aPhileasFogg.
	model addDependent: self.! !

!PhileasFoggController methodsFor: 'view organazing' stamp: 'hjo 11/18/2011 20:21'!
moveInstanceVariablesMorphBelowTopicClassNameMorph

	instanceVariablesMorph top: contentViewOfScrollPane top + 50.
	instanceVariablesMorph left: contentViewOfScrollPane left + 30.
! !

!PhileasFoggController methodsFor: 'view organazing' stamp: 'hjo 11/19/2011 17:55'!
moveScrollPaneToFitResetOfTheArea

	self scrollPane top: self classNameTextMorph bottom.
	self scrollPane left: self contentView left.
	self scrollPane width: self contentView width.
	self scrollPane height: self contentView bottom - self classNameTextMorph bottom.! !

!PhileasFoggController methodsFor: 'view organazing' stamp: 'hjo 11/18/2011 20:23'!
moveUserClassButtonesMorphBelowInstanceVariablesMorph

	self userClassButtonesMorph top: self instanceVariablesMorph bottom + 50.
	self userClassButtonesMorph left: 0.! !

!PhileasFoggController methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 17:25'!
nameOfSuperclass

	^model nameOfSuperclassOfTopicClass ! !

!PhileasFoggController methodsFor: 'as yet unclassified' stamp: 'hjo 11/19/2011 17:57'!
reorganizeViews

	self moveScrollPaneToFitResetOfTheArea.
	self moveInstanceVariablesMorphBelowTopicClassNameMorph.
	self moveUserClassButtonesMorphBelowInstanceVariablesMorph.
	self resizeUserClassButtonesMorphToFitButtons.

	contentViewOfScrollPane width: self scrollPane width.
	contentViewOfScrollPane height: self userClassButtonesMorph bottom.! !

!PhileasFoggController methodsFor: 'view organazing' stamp: 'hjo 11/19/2011 17:50'!
resizeUserClassButtonesMorphToFitButtons

	self userClassButtonesMorph width: (buttons isEmpty ifTrue: [30] ifFalse: [(buttons collect: #width) max]).
	self userClassButtonesMorph height: (buttons isEmpty ifTrue: [30] ifFalse: [(buttons collect: #height) sum]).! !

!PhileasFoggController methodsFor: 'view making' stamp: 'hjo 11/19/2011 18:06'!
scrollPane

	scrollPane isNil ifTrue: [
		scrollPane := ScrollPane new.
		contentViewOfScrollPane := Morph new.
		contentViewOfScrollPane color: Color transparent.
		contentViewOfScrollPane extent: 1000@1000.
		scrollPane scroller addMorph: contentViewOfScrollPane.
		contentViewOfScrollPane addMorph: self instanceVariablesMorph.
		contentViewOfScrollPane addMorph: self userClassButtonesMorph.
		].
	^scrollPane! !

!PhileasFoggController methodsFor: 'view making' stamp: 'hjo 11/14/2011 17:17'!
superclassButton

	^superclassButton ifNil: [superclassButton := PluggableButtonMorph on: self getState: nil action: #goSuperclass label: #nameOfSuperclass  ].! !

!PhileasFoggController methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 12:02'!
topicClass: aClass 

	model topicClass: aClass  ! !

!PhileasFoggController methodsFor: 'as yet unclassified' stamp: 'hjo 11/19/2011 17:43'!
update: aSymbol

	aSymbol = #topicClass ifTrue: [ 
		self changed: #nameOfSuperclass.
		classNameTextMorph contents: model nameOfTopicClass. 
		instanceVariablesMorph contents: model paragraphOfInstanceVariableNames.
		self moveInstanceVariablesMorphBelowTopicClassNameMorph.
		self moveUserClassButtonesMorphBelowInstanceVariablesMorph.
		self createButtonList.
		self reorganizeViews.
		^self ].
	Transcript show: aSymbol;cr;flush.  ! !

!PhileasFoggController methodsFor: 'view making' stamp: 'hjo 11/17/2011 21:03'!
userClassButtonesMorph

	^userClassButtonesMorph ifNil:
	[	|  lastButton |
		userClassButtonesMorph := Morph new.
		userClassButtonesMorph color: Color transparent.
		self moveUserClassButtonesMorphBelowInstanceVariablesMorph.
		self createButtonList.
		userClassButtonesMorph.
	]! !

!PhileasFoggController methodsFor: 'view making' stamp: 'hjo 11/18/2011 20:11'!
window

	window ifNil: [
		window := self contentView openInWindow.
		self reorganizeViews.
		window setLabel: 'Phileas Fogg' ]  ! !

Object subclass: #PhileasFoggTranscriptor
	instanceVariableNames: 'topicClass model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PhileasFogg'!

!PhileasFoggTranscriptor methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 11:51'!
initialize

	super initialize.
	model := PhileasFogg new.! !

!PhileasFoggTranscriptor methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 11:57'!
main
	Transcript clear.
	self transcriptLine: '- class name -'.
	self transcriptLine: model nameOfTopicClass.
	self transcriptLine: '- superclass name -'.
	self transcriptLine: model nameOfSuperclassOfTopicClass.
	self transcriptLine: '- instance variable names -'.
	model instanceVariableNamesOfTopicClass do: [ :each | self transcriptLine: each ].
	self transcriptLine: '- referencing classes -'.
	model classesReferencingTopicClass do: [ :each | self transcriptLine: each printString ].
	self transcriptLine: '- end -'.
	Transcript flush! !

!PhileasFoggTranscriptor methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 12:15'!
model: aPhileasFogg 

	model := aPhileasFogg! !

!PhileasFoggTranscriptor methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 11:50'!
topicClass: aClass 

	model topicClass: aClass! !

!PhileasFoggTranscriptor methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 11:47'!
transcriptLine: aString
	^ Transcript
		nextPutAll: aString;
		cr! !
